/* USBasp main.c */
/* ̉ǂ́Airuka񂪍s܂
   2008N912`922
   2008N922 eXgJJn
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

#include "usbdrv.h"
#include "hidcmd.h"

#define OPTIMIZE_SIZE		1

/* ------------------------------------------------------------------------- */
//	RtBM[VXCb`:
#define	INCLUDE_FUSION		1	// Z߂.
#define	INCLUDE_MONITOR_CMD 1	// 62:POKE(),63:PEEK().
#define	INCLUDE_LED_CMD 	1	// 02:SET_STATUS().
/* ------------------------------------------------------------------------- */


//	REPORT_ID.
#define ID1    1
#define ID2    2
#define ID3    3

//	REPORT_COUNT+2̒l.
#define	LENGTH1  8
#define	LENGTH2 32
#define	LENGTH3 40

PROGMEM char usbHidReportDescriptor[42] = {
    0x06, 0x00, 0xff,              // USAGE_PAGE (Generic Desktop)
    0x09, 0x01,                    // USAGE (Vendor Usage 1)
    0xa1, 0x01,                    // COLLECTION (Application)
    0x15, 0x00,                    //   LOGICAL_MINIMUM (0)
    0x26, 0xff, 0x00,              //   LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //   REPORT_SIZE (8)

    0x85, 0x01,                    //   REPORT_ID (1)
    0x95, 0x06,                    //   REPORT_COUNT (6)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0x85, 0x02,                    //   REPORT_ID (2)
    0x95, 0x1e,                    //   REPORT_COUNT (30)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0x85, 0x03,                    //   REPORT_ID (3)
    0x95, 0x26,                    //   REPORT_COUNT (38)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0xc0                           // END_COLLECTION
};
/* Note: REPORT_COUNT does not include report-ID byte */

#if	INCLUDE_FUSION
#define	DEV_ID				0x55	// FUSIOÑt@[.
#else
#define	DEV_ID				0x5a	// FUSIONȂ̃t@[.
#endif

//
//	Mobt@.
//
#if OPTIMIZE_SIZE
register uchar currentPosition asm("r5");
register uchar bytesRemaining asm("r6");
register uchar page_mode asm("r4");
#else
static uchar currentPosition, bytesRemaining; // Receive Data Pointer
static uchar    page_mode;
#endif

typedef struct {
	uchar id[1];
	uchar buf[39];
} ReportBuf_t;

static ReportBuf_t report;

// Mobt@͎Mobt@𗬗p.
//	AA擪1oCgReport IDuKv̂,1oCg.
#define	usbData report.buf
#define	buffer  report.id

//
#if	INCLUDE_MONITOR_CMD

//	[ǂݏR}h\.
typedef struct {
	uchar hidasp_cmd;	// 62=poke 63=peek
	uchar count;		// ǂݍ݃oCg.
	uchar *addr;		// ǂݏAhX.
	uchar memdata[16];	// ǂݍ݃f[^. ͏݃f[^[0] }XN[1]
} MonCommand_t;

static void cmd_peek_poke(MonCommand_t *cmd,uchar data0)
{
	uchar *p =cmd->addr;
	if(data0 == HIDASP_PEEK) {
//	if(cmd->hidasp_cmd == HIDASP_PEEK) {
		//[Aǂݏo.
		uchar cnt=cmd->count;
		uchar i;
		for(i=0;i<cnt;i++) {
			usbData[i]= *p++;
		}
	}else{
		//[.(PoCg)
		uchar data=cmd->memdata[0];
		uchar mask=cmd->memdata[1];
		if(mask) {	//}XNt̏.
			*p = (*p & mask) | data;
		}else{			//ׂ.
			*p = data;
		}
	}
}

#endif



// œKp
#define hbyte(a) (*((uchar*)&(a)+1))
#define lbyte(a) (*((uchar*)&(a)))
inline static uint8_t byte(uint8_t t) {return t;}

/* ------------------------------------------------------------------------- */
/* -----------------------------  USI Transfer  ---------------------------- */
/* ------------------------------------------------------------------------- */

static uint8_t wait=60; // 160

//	for ATmega88

static uint8_t usi_trans(uint8_t data)
{
	
}

static inline void isp_command(uint8_t *data){
	uchar i;
	for (i=0;i<4;i++) {
		usbData[i]=usi_trans(data[i]);
	}
}

/* ------------------------------------------------------------------------- */
/* ----------------------------- execute Buffer ---------------------------- */
/* ------------------------------------------------------------------------- */
//
//		hidasp̃C.
//
//	Mobt@ƎMobt@ʂȂ̂ŁA
//	ׂƂ̃f[^gȂ悤ɒ.

void hidasp_main()	//uchar *data)
{
	// {Ȃ.
	uchar *data = report.buf;	//Ək.

//	static uchar    page_mode;
	static uint16_t page_addr;
	uchar i;
	uint8_t data0 = data[0];
	uint8_t data1 = data[1];
	uint8_t cmd   = data0 & 0xfe;
	uint8_t cmdtx = data0 & CMD_MASK;

#if 1
	usbData[0] = DEV_ID;
#else
	if ( data0 == HIDASP_TEST ) { // TEST
		usbData[0] = DEV_ID;
	}else
#endif
#if	INCLUDE_LED_CMD
	if ( data0 == HIDASP_SET_STATUS ) { // SET_LED
		PORTD = (PORTD&~3)    | (data1 & 3);
//		PORTB = (PORTB&~0x10) | (data[2]&0x1F);
		// RESETsێAȊOORo
		PORTB = (PORTB&~0x1F) | (data[2]&0x1f) ;
		usbData[0] = 0xaa;
	} else
#endif
	if ( cmd == HIDASP_CMD_TX) { // SPI
		isp_command(data+1);
	} else if ( data0 == HIDASP_SET_PAGE ) { // Page set
		page_mode = data1;
		page_addr = 0;
	}
#if	INCLUDE_FUSION
	else if (cmdtx == HIDASP_PAGE_TX ) { // Page buf
		//
		//	page_writeJnpage_addrdata[1]ŏ.
		//
		if(data0 & (HIDASP_PAGE_TX_START & MODE_MASK)) {
			page_mode = 0x40;
			page_addr = 0;
		}
		//
		//	page_write (܂page_read) ̎s.
		//
		for(i=0;i<data1;i++) {
			usi_trans(page_mode);
			usi_trans(hbyte(page_addr));
			usi_trans(lbyte(page_addr));
			usbData[i]=usi_trans(data[i+2]);
			if (page_mode & 0x88) { // EEPROM or FlashH
				page_addr++;
				page_mode&=~0x08;
			} else {
				page_mode|=0x08;
			}
		}
		//
		//	isp_command(Flash)̎s.
		//
		if(data0 & (HIDASP_PAGE_TX_FLUSH & MODE_MASK)) {
			isp_command(data+i+2);
		}
	}
#else
	else if ( cmd == HIDASP_PAGE_TX ) { // Page buf
		for(i=0;i<data1;i++) {
			usi_trans(page_mode);
			usi_trans(hbyte(page_addr));
			usi_trans(lbyte(page_addr));
			usbData[i]=usi_trans(data[i+2]);
			if (page_mode & 0x88) { // EEPROM or FlashH
				page_addr++;
				page_mode&=~0x08;
			} else {
				page_mode|=0x08;
			}
		}
	}
#endif
	else if ( data0 == HIDASP_SET_DELAY ) { // Set wait
		wait=data1;
	}
#if	INCLUDE_MONITOR_CMD
	else if ( cmd == HIDASP_POKE ) {
		cmd_peek_poke((MonCommand_t *)data,data0);
	}
#endif
}


/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */

// ftHgȊO usb setup R}hpPbgŉ߂.
uchar usbFunctionSetup(uchar data[8])
{
	usbRequest_t	*rq = (void *)data;
	uchar			rqType = rq->bmRequestType & USBRQ_TYPE_MASK;
	uchar			bRequest = rq->bRequest;
    if(rqType == USBRQ_TYPE_CLASS){    /* class request type */
        if(	bRequest == USBRQ_HID_GET_REPORT ) {
			report.id[0] = rq->wValue.bytes[0];    /* store report ID */
			usbMsgPtr = report.id;
			return rq->wLength.word;
		}
        if(	bRequest == USBRQ_HID_SET_REPORT ) {
		    currentPosition = 0;                // initialize position index
        	bytesRemaining = rq->wLength.word;  // store the amount of data requested
#if	0
        	if(	bytesRemaining > sizeof(report)) { // limit to buffer size
            	bytesRemaining = sizeof(report);
			}
#endif
          	return 0xff;						// tell driver to use usbFunctionWrite()
        }
    }
    return 0;
}


// Rg[]㑱f[^ĂꍇA8oCgPʂŎ󂯎.
// 	Eʂreport\̂ɓ.
//	ES󂯎Ahidasp_main()Ăяo.
uchar usbFunctionWrite(uchar *data, uchar len)
{
    uchar i;
    if(	len > bytesRemaining) {             // if this is the last incomplete chunk
        len = bytesRemaining;               // limit to the amount we can store
	}
    bytesRemaining -= len;
    for(i = 0; i < len; i++) {
        report.id[currentPosition++] = *data++;
	}
	// S󂯎Aobt@es.
    if( bytesRemaining == 0 ) {
		hidasp_main();		//(report.buf);
	    return 1;	// return 1 if we have all data
	}
	return 0;		// continue data.
}

static void hardwareInit(void) {
  uchar    i, j;

  /* activate pull-ups except on USB lines */
  USB_CFG_IOPORT   = (uchar)~((1<<USB_CFG_DMINUS_BIT)|(1<<USB_CFG_DPLUS_BIT));
  /* all pins input except USB (-> USB reset) */
#ifdef USB_CFG_PULLUP_IOPORT    /* use usbDeviceConnect()/usbDeviceDisconnect() if available */
  USBDDR    = 0;    /* we do RESET by deactivating pullup */
  usbDeviceDisconnect();
#else
  USBDDR    = (1<<USB_CFG_DMINUS_BIT)|(1<<USB_CFG_DPLUS_BIT);
#endif

  j = 0;
  while(--j){          /* USB Reset by device only required on Watchdog Reset */
    i = 0;
    while(--i);      /* delay >10ms for USB reset */
  }
#ifdef USB_CFG_PULLUP_IOPORT
  usbDeviceConnect();
#else
  USBDDR    = 0;      /*  remove USB reset condition */
#endif
}
/*
                          ATmega88
                         ___    ___
    (PCINT14/_RESET)PC6 [1  |__| 28] PC5(ADC5/SCL/PCINT13)
       (PCINT16/RxD)PD0 [2       27] PC4(ADC4/SDA/PCINT12)
       (PCINT17/TxD)PD1 [3       26] PC3(ADC3/PCINT11)
      (PCINT18/INT0)PD2 [4       25] PC2(ADC2/PCINT10)
 (PCINT19/OC2B/INT1)PD3 [5       24] PC1(ADC1/PCINT9)
    (PCINT20/XCK/T0)PD4 [6       23] PC0(ADC0/PCINT8)
                    Vcc [7       22] GND
                    GND [8       21] AREF
(PCINT6/XTAL1/TOSC1)PB6 [9       20] AVcc
(PCINT7/XTAL2/TOSC2)PB7 [10      19] PB5(SCK/PCINT5)
   (PCINT21/OC0B/T1)PD5 [11      18] PB4(MISO/PCINT3)
 (PCINT22/OC0A/AIN0)PD6 [12      17] PB3(MOSI/OC2A/PCINT3)
      (PCINT23/AIN1)PD7 [13      16] PB2(_SS/OC1B/PCINT2)
  (PCINT0/CLKO/ICP1)PB0 [14      15] PB1(OC1A/PCINT1)
                         ~~~~~~~~~~

   ---------------------------------------
   USB:     PD3   ===> USB D-
            PD2   ===> USB D+
   XTAL:    XTAL1,2 => Crystal 12MHz
   ---------------------------------------
*/

int main(void)
{
#if	0
  uchar	  i, j;

  PORTD	= 0;
  PORTB	= 0;			/* no pullups on USB and ISP pins */
  DDRD = ~(1 <<	2);		/* all outputs except PD2 =	INT0 */

  DDRB = ~0;			/* output SE0 for USB reset	*/
  j	= 0;
  while(--j){			/* USB Reset by	device only	required on	Watchdog Reset */
	  i	= 0;
	  while(--i);		/* delay >10ms for USB reset */
  }
  DDRB = 0;				/* all USB and ISP pins	inputs */

  DDRC = 0x03;			/* all inputs except PC0, PC1 */
  PORTC	= 0xfe;
#endif
	hardwareInit();

#if	0
//	j^R}hL  SCK,MOSIHi-Z܂ŃzXgs.
	DDRD = 0;	//~USBMASK;        /* all outputs except USB data */
	PORTB = (1<<3);			/* PB3 LED(PWR) ON, PB2 LED(ACC) OFF */
	DDRB = 0x0;			/* PB7-4=in PB3-0=out */
//	USICR=(1<<USIWM0)|(1<<USICS1)|(1<<USICLK);
#endif

#if	0
	//Qlp
	//	gppin͐ݒɂĂ.
	DDRD = 0; 	// c{Ac|܂߁APORTDׂē̓[hɂB
	PORTB = (1<<4)|(1<<3);	/* RESET=High, PB3 LED(PWR) ON, PB2 LED(ACC) OFF */

	// PORTB[3,2,1,0]̓[hɂ.
	DDRB = 0xd0;	// 1101_0000 input = USI input data , PB3,2,1,0
	USICR=(1<<USIWM0)|(1<<USICS1)|(1<<USICLK);

	// ToDo:ڑpinɃvAbvݒ肪Kv.
#endif

    usbInit();
    sei();
    for(;;){    /* main event loop */
        usbPoll();
    }
    return 0;
}
